#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;

#endregion



#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		
		private TradeLikeAProEF.MarketSessions[] cacheMarketSessions;
		private TradeLikeAProEF.OpenDay[] cacheOpenDay;
		private TradeLikeAProEF.OpenWeek[] cacheOpenWeek;
		private TradeLikeAProEF.PriorDay[] cachePriorDay;
		private TradeLikeAProEF.PriorWeek[] cachePriorWeek;
		private TradeLikeAProEF.VelaDisparador[] cacheVelaDisparador;

		
		public TradeLikeAProEF.MarketSessions MarketSessions(DateTime americanSessionStartTime, bool drawNYFirstHourHighLow, DashStyleHelper firstHourLineStyle, int firstHourLineWidth, DateTime asiaSessionStartTime, DateTime europeSessionStartTime)
		{
			return MarketSessions(Input, americanSessionStartTime, drawNYFirstHourHighLow, firstHourLineStyle, firstHourLineWidth, asiaSessionStartTime, europeSessionStartTime);
		}

		public TradeLikeAProEF.OpenDay OpenDay()
		{
			return OpenDay(Input);
		}

		public TradeLikeAProEF.OpenWeek OpenWeek(int weeksBack, int lineWidth, DashStyleHelper lineStyle, DayOfWeek startDay)
		{
			return OpenWeek(Input, weeksBack, lineWidth, lineStyle, startDay);
		}

		public TradeLikeAProEF.PriorDay PriorDay()
		{
			return PriorDay(Input);
		}

		public TradeLikeAProEF.PriorWeek PriorWeek(DayOfWeek weekStartDay, bool showExtensions)
		{
			return PriorWeek(Input, weekStartDay, showExtensions);
		}

		public TradeLikeAProEF.VelaDisparador VelaDisparador()
		{
			return VelaDisparador(Input);
		}


		
		public TradeLikeAProEF.MarketSessions MarketSessions(ISeries<double> input, DateTime americanSessionStartTime, bool drawNYFirstHourHighLow, DashStyleHelper firstHourLineStyle, int firstHourLineWidth, DateTime asiaSessionStartTime, DateTime europeSessionStartTime)
		{
			if (cacheMarketSessions != null)
				for (int idx = 0; idx < cacheMarketSessions.Length; idx++)
					if (cacheMarketSessions[idx].AmericanSessionStartTime == americanSessionStartTime && cacheMarketSessions[idx].DrawNYFirstHourHighLow == drawNYFirstHourHighLow && cacheMarketSessions[idx].FirstHourLineStyle == firstHourLineStyle && cacheMarketSessions[idx].FirstHourLineWidth == firstHourLineWidth && cacheMarketSessions[idx].AsiaSessionStartTime == asiaSessionStartTime && cacheMarketSessions[idx].EuropeSessionStartTime == europeSessionStartTime && cacheMarketSessions[idx].EqualsInput(input))
						return cacheMarketSessions[idx];
			return CacheIndicator<TradeLikeAProEF.MarketSessions>(new TradeLikeAProEF.MarketSessions(){ AmericanSessionStartTime = americanSessionStartTime, DrawNYFirstHourHighLow = drawNYFirstHourHighLow, FirstHourLineStyle = firstHourLineStyle, FirstHourLineWidth = firstHourLineWidth, AsiaSessionStartTime = asiaSessionStartTime, EuropeSessionStartTime = europeSessionStartTime }, input, ref cacheMarketSessions);
		}

		public TradeLikeAProEF.OpenDay OpenDay(ISeries<double> input)
		{
			if (cacheOpenDay != null)
				for (int idx = 0; idx < cacheOpenDay.Length; idx++)
					if ( cacheOpenDay[idx].EqualsInput(input))
						return cacheOpenDay[idx];
			return CacheIndicator<TradeLikeAProEF.OpenDay>(new TradeLikeAProEF.OpenDay(), input, ref cacheOpenDay);
		}

		public TradeLikeAProEF.OpenWeek OpenWeek(ISeries<double> input, int weeksBack, int lineWidth, DashStyleHelper lineStyle, DayOfWeek startDay)
		{
			if (cacheOpenWeek != null)
				for (int idx = 0; idx < cacheOpenWeek.Length; idx++)
					if (cacheOpenWeek[idx].WeeksBack == weeksBack && cacheOpenWeek[idx].LineWidth == lineWidth && cacheOpenWeek[idx].LineStyle == lineStyle && cacheOpenWeek[idx].StartDay == startDay && cacheOpenWeek[idx].EqualsInput(input))
						return cacheOpenWeek[idx];
			return CacheIndicator<TradeLikeAProEF.OpenWeek>(new TradeLikeAProEF.OpenWeek(){ WeeksBack = weeksBack, LineWidth = lineWidth, LineStyle = lineStyle, StartDay = startDay }, input, ref cacheOpenWeek);
		}

		public TradeLikeAProEF.PriorDay PriorDay(ISeries<double> input)
		{
			if (cachePriorDay != null)
				for (int idx = 0; idx < cachePriorDay.Length; idx++)
					if ( cachePriorDay[idx].EqualsInput(input))
						return cachePriorDay[idx];
			return CacheIndicator<TradeLikeAProEF.PriorDay>(new TradeLikeAProEF.PriorDay(), input, ref cachePriorDay);
		}

		public TradeLikeAProEF.PriorWeek PriorWeek(ISeries<double> input, DayOfWeek weekStartDay, bool showExtensions)
		{
			if (cachePriorWeek != null)
				for (int idx = 0; idx < cachePriorWeek.Length; idx++)
					if (cachePriorWeek[idx].WeekStartDay == weekStartDay && cachePriorWeek[idx].ShowExtensions == showExtensions && cachePriorWeek[idx].EqualsInput(input))
						return cachePriorWeek[idx];
			return CacheIndicator<TradeLikeAProEF.PriorWeek>(new TradeLikeAProEF.PriorWeek(){ WeekStartDay = weekStartDay, ShowExtensions = showExtensions }, input, ref cachePriorWeek);
		}

		public TradeLikeAProEF.VelaDisparador VelaDisparador(ISeries<double> input)
		{
			if (cacheVelaDisparador != null)
				for (int idx = 0; idx < cacheVelaDisparador.Length; idx++)
					if ( cacheVelaDisparador[idx].EqualsInput(input))
						return cacheVelaDisparador[idx];
			return CacheIndicator<TradeLikeAProEF.VelaDisparador>(new TradeLikeAProEF.VelaDisparador(), input, ref cacheVelaDisparador);
		}

	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		
		public Indicators.TradeLikeAProEF.MarketSessions MarketSessions(DateTime americanSessionStartTime, bool drawNYFirstHourHighLow, DashStyleHelper firstHourLineStyle, int firstHourLineWidth, DateTime asiaSessionStartTime, DateTime europeSessionStartTime)
		{
			return indicator.MarketSessions(Input, americanSessionStartTime, drawNYFirstHourHighLow, firstHourLineStyle, firstHourLineWidth, asiaSessionStartTime, europeSessionStartTime);
		}

		public Indicators.TradeLikeAProEF.OpenDay OpenDay()
		{
			return indicator.OpenDay(Input);
		}

		public Indicators.TradeLikeAProEF.OpenWeek OpenWeek(int weeksBack, int lineWidth, DashStyleHelper lineStyle, DayOfWeek startDay)
		{
			return indicator.OpenWeek(Input, weeksBack, lineWidth, lineStyle, startDay);
		}

		public Indicators.TradeLikeAProEF.PriorDay PriorDay()
		{
			return indicator.PriorDay(Input);
		}

		public Indicators.TradeLikeAProEF.PriorWeek PriorWeek(DayOfWeek weekStartDay, bool showExtensions)
		{
			return indicator.PriorWeek(Input, weekStartDay, showExtensions);
		}

		public Indicators.TradeLikeAProEF.VelaDisparador VelaDisparador()
		{
			return indicator.VelaDisparador(Input);
		}


		
		public Indicators.TradeLikeAProEF.MarketSessions MarketSessions(ISeries<double> input , DateTime americanSessionStartTime, bool drawNYFirstHourHighLow, DashStyleHelper firstHourLineStyle, int firstHourLineWidth, DateTime asiaSessionStartTime, DateTime europeSessionStartTime)
		{
			return indicator.MarketSessions(input, americanSessionStartTime, drawNYFirstHourHighLow, firstHourLineStyle, firstHourLineWidth, asiaSessionStartTime, europeSessionStartTime);
		}

		public Indicators.TradeLikeAProEF.OpenDay OpenDay(ISeries<double> input )
		{
			return indicator.OpenDay(input);
		}

		public Indicators.TradeLikeAProEF.OpenWeek OpenWeek(ISeries<double> input , int weeksBack, int lineWidth, DashStyleHelper lineStyle, DayOfWeek startDay)
		{
			return indicator.OpenWeek(input, weeksBack, lineWidth, lineStyle, startDay);
		}

		public Indicators.TradeLikeAProEF.PriorDay PriorDay(ISeries<double> input )
		{
			return indicator.PriorDay(input);
		}

		public Indicators.TradeLikeAProEF.PriorWeek PriorWeek(ISeries<double> input , DayOfWeek weekStartDay, bool showExtensions)
		{
			return indicator.PriorWeek(input, weekStartDay, showExtensions);
		}

		public Indicators.TradeLikeAProEF.VelaDisparador VelaDisparador(ISeries<double> input )
		{
			return indicator.VelaDisparador(input);
		}
	
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		
		public Indicators.TradeLikeAProEF.MarketSessions MarketSessions(DateTime americanSessionStartTime, bool drawNYFirstHourHighLow, DashStyleHelper firstHourLineStyle, int firstHourLineWidth, DateTime asiaSessionStartTime, DateTime europeSessionStartTime)
		{
			return indicator.MarketSessions(Input, americanSessionStartTime, drawNYFirstHourHighLow, firstHourLineStyle, firstHourLineWidth, asiaSessionStartTime, europeSessionStartTime);
		}

		public Indicators.TradeLikeAProEF.OpenDay OpenDay()
		{
			return indicator.OpenDay(Input);
		}

		public Indicators.TradeLikeAProEF.OpenWeek OpenWeek(int weeksBack, int lineWidth, DashStyleHelper lineStyle, DayOfWeek startDay)
		{
			return indicator.OpenWeek(Input, weeksBack, lineWidth, lineStyle, startDay);
		}

		public Indicators.TradeLikeAProEF.PriorDay PriorDay()
		{
			return indicator.PriorDay(Input);
		}

		public Indicators.TradeLikeAProEF.PriorWeek PriorWeek(DayOfWeek weekStartDay, bool showExtensions)
		{
			return indicator.PriorWeek(Input, weekStartDay, showExtensions);
		}

		public Indicators.TradeLikeAProEF.VelaDisparador VelaDisparador()
		{
			return indicator.VelaDisparador(Input);
		}


		
		public Indicators.TradeLikeAProEF.MarketSessions MarketSessions(ISeries<double> input , DateTime americanSessionStartTime, bool drawNYFirstHourHighLow, DashStyleHelper firstHourLineStyle, int firstHourLineWidth, DateTime asiaSessionStartTime, DateTime europeSessionStartTime)
		{
			return indicator.MarketSessions(input, americanSessionStartTime, drawNYFirstHourHighLow, firstHourLineStyle, firstHourLineWidth, asiaSessionStartTime, europeSessionStartTime);
		}

		public Indicators.TradeLikeAProEF.OpenDay OpenDay(ISeries<double> input )
		{
			return indicator.OpenDay(input);
		}

		public Indicators.TradeLikeAProEF.OpenWeek OpenWeek(ISeries<double> input , int weeksBack, int lineWidth, DashStyleHelper lineStyle, DayOfWeek startDay)
		{
			return indicator.OpenWeek(input, weeksBack, lineWidth, lineStyle, startDay);
		}

		public Indicators.TradeLikeAProEF.PriorDay PriorDay(ISeries<double> input )
		{
			return indicator.PriorDay(input);
		}

		public Indicators.TradeLikeAProEF.PriorWeek PriorWeek(ISeries<double> input , DayOfWeek weekStartDay, bool showExtensions)
		{
			return indicator.PriorWeek(input, weekStartDay, showExtensions);
		}

		public Indicators.TradeLikeAProEF.VelaDisparador VelaDisparador(ISeries<double> input )
		{
			return indicator.VelaDisparador(input);
		}

	}
}

#endregion
